"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = resetPassword;
const query_dsql_api_1 = __importDefault(require("../../functions/api/query-dsql-api"));
const grab_api_path_1 = __importDefault(require("../../utils/backend/users/grab-api-path"));
const api_reset_user_password_1 = __importDefault(require("../../functions/api/users/api-reset-user-password"));
/**
 * # Reset User Password
 */
function resetPassword(params) {
    return __awaiter(this, void 0, void 0, function* () {
        if (params.useLocal) {
            return yield (0, api_reset_user_password_1.default)(params);
        }
        const httpResponse = yield (0, query_dsql_api_1.default)({
            path: (0, grab_api_path_1.default)({
                paradigm: "auth",
                action: "reset-password",
                database: params.database,
                apiVersion: params.apiVersion,
            }),
            apiKey: params.apiKey,
            body: params,
            method: "POST",
        });
        return httpResponse;
    });
}
