"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = updateUser;
const api_update_user_1 = __importDefault(require("../../functions/api/users/api-update-user"));
const query_dsql_api_1 = __importDefault(require("../../functions/api/query-dsql-api"));
const grab_api_path_1 = __importDefault(require("../../utils/backend/users/grab-api-path"));
/**
 * # Update User
 */
function updateUser(_a) {
    return __awaiter(this, arguments, void 0, function* ({ payload, database, updatedUserId, useLocal, apiKey, apiVersion, dbUserId, }) {
        const updateUserParams = {
            payload: payload,
            database,
            updatedUserId,
            dbUserId,
        };
        if (useLocal) {
            return yield (0, api_update_user_1.default)(updateUserParams);
        }
        /**
         * Make https request
         *
         * @description make a request to datasquirel.com
         */
        const httpResponse = yield (0, query_dsql_api_1.default)({
            path: (0, grab_api_path_1.default)({
                paradigm: "auth",
                action: "update",
                database,
                apiVersion,
            }),
            apiKey,
            body: updateUserParams,
            method: "POST",
        });
        return httpResponse;
    });
}
