"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = validateTempEmailCode;
const get_auth_cookie_names_1 = __importDefault(require("../../functions/backend/cookies/get-auth-cookie-names"));
const parseCookies_1 = __importDefault(require("../../utils/backend/parseCookies"));
const decrypt_1 = __importDefault(require("../../functions/dsql/decrypt"));
const ejson_1 = __importDefault(require("../../utils/ejson"));
/**
 * # Verify the temp email code sent to the user's email address
 */
function validateTempEmailCode(_a) {
    return __awaiter(this, arguments, void 0, function* ({ request, email, cookieString, code, }) {
        try {
            const keyNames = (0, get_auth_cookie_names_1.default)();
            const oneTimeCodeCookieName = keyNames.oneTimeCodeName;
            const cookies = (0, parseCookies_1.default)({ request, cookieString });
            const encryptedOneTimeCode = cookies[oneTimeCodeCookieName];
            const encryptedPayload = (0, decrypt_1.default)({
                encryptedString: encryptedOneTimeCode,
            });
            const payload = ejson_1.default.parse(encryptedPayload);
            if ((payload === null || payload === void 0 ? void 0 : payload.email) && !email) {
                return payload;
            }
            if ((payload === null || payload === void 0 ? void 0 : payload.email) && payload.email === email) {
                return payload;
            }
            return null;
        }
        catch (error) {
            console.log("validateTempEmailCode error:", error.message);
            return null;
        }
    });
}
