"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = facebookLogin;
const dbHandler_1 = __importDefault(require("../../backend/dbHandler"));
const serverError_1 = __importDefault(require("../../backend/serverError"));
const hashPassword_1 = __importDefault(require("../../dsql/hashPassword"));
/**
 * # Facebook Login
 */
function facebookLogin(_a) {
    return __awaiter(this, arguments, void 0, function* ({ usertype, body, }) {
        try {
            const foundUser = (yield (0, dbHandler_1.default)({
                query: `SELECT * FROM users WHERE email='${body.facebookUserEmail}' AND social_login='1'`,
                values: [body.facebookUserEmail],
            }));
            if (foundUser && foundUser[0]) {
                return foundUser[0];
            }
            let socialHashedPassword = (0, hashPassword_1.default)({
                password: body.facebookUserId,
            });
            let newUser = (yield (0, dbHandler_1.default)({
                query: `INSERT INTO ${usertype} (
            first_name,
            last_name,
            social_platform,
            social_name,
            email,
            image,
            image_thumbnail,
            password,
            verification_status,
            social_login,
            social_id,
            terms_agreement,
            date_created,
            date_code
            ) VALUES (
                '${body.facebookUserFirstName}',
                '${body.facebookUserLastName}',
                'facebook',
                'facebook_${body.facebookUserEmail
                    ? body.facebookUserEmail.replace(/@.*/, "")
                    : body.facebookUserFirstName.toLowerCase()}',
                '${body.facebookUserEmail}',
                '${body.facebookUserImage}',
                '${body.facebookUserImage}',
                '${socialHashedPassword}',
                '1',
                '1',
                '${body.facebookUserId}',
                '1',
                '${Date()}',
                '${Date.now()}'
                )`,
                values: [
                    body.facebookUserFirstName,
                    body.facebookUserLastName,
                    body.facebookUserEmail,
                    body.facebookUserImage,
                    socialHashedPassword,
                    body.facebookUserId,
                ],
            }));
            const newFoundUser = (yield (0, dbHandler_1.default)({
                query: `SELECT * FROM ${usertype} WHERE id=?`,
                values: (newUser === null || newUser === void 0 ? void 0 : newUser.insertId) ? [newUser === null || newUser === void 0 ? void 0 : newUser.insertId] : [],
            }));
        }
        catch ( /** @type {any} */error) {
            (0, serverError_1.default)({
                component: "functions/backend/facebookLogin",
                message: error.message,
            });
        }
        return {
            isFacebookAuthValid: false,
            newFoundUser: null,
        };
    });
}
