"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = apiGetUser;
const grab_db_full_name_1 = __importDefault(require("../../../utils/grab-db-full-name"));
const dbHandler_1 = __importDefault(require("../../backend/dbHandler"));
/**
 * # API Get User
 */
function apiGetUser(_a) {
    return __awaiter(this, arguments, void 0, function* ({ fields, database, userId, dbUserId, selectAll, }) {
        const finalDbName = (0, grab_db_full_name_1.default)({ dbName: database, userId: dbUserId });
        const selectFields = selectAll ? "*" : (fields === null || fields === void 0 ? void 0 : fields[0]) ? fields.join(",") : "*";
        let foundUser = (yield (0, dbHandler_1.default)({
            query: `SELECT ${selectFields} FROM users WHERE id=?`,
            values: [userId],
            database: finalDbName,
        }));
        if (!foundUser || !foundUser[0]) {
            return {
                success: false,
                payload: null,
            };
        }
        return {
            success: true,
            payload: foundUser[0],
        };
    });
}
