"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = apiSendResetPasswordLink;
const grab_db_full_name_1 = __importDefault(require("../../../../utils/grab-db-full-name"));
const dbHandler_1 = __importDefault(require("../../../backend/dbHandler"));
/**
 * # API Login
 */
function apiSendResetPasswordLink(_a) {
    return __awaiter(this, arguments, void 0, function* ({ database, email, dbUserId, debug, }) {
        const dbFullName = (0, grab_db_full_name_1.default)({ dbName: database, userId: dbUserId });
        if (!dbFullName) {
            return {
                success: false,
                msg: `Couldn't get database full name`,
            };
        }
        if (email === null || email === void 0 ? void 0 : email.match(/ /)) {
            return {
                success: false,
                msg: "Invalid Email/Password format",
            };
        }
        let foundUser = (yield (0, dbHandler_1.default)({
            query: `SELECT * FROM ${dbFullName}.users WHERE email = ? OR username = ?`,
            values: [email, email],
            database: dbFullName,
        }));
        if (debug) {
            console.log("apiSendResetPassword:foundUser:", foundUser);
        }
        const targetUser = foundUser === null || foundUser === void 0 ? void 0 : foundUser[0];
        if (!targetUser)
            return {
                success: false,
                msg: "No user found",
            };
        return { success: true };
    });
}
