"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = suAddBackup;
const write_backup_files_1 = __importDefault(require("./write-backup-files"));
const grab_dir_names_1 = __importDefault(require("../../../../../utils/backend/names/grab-dir-names"));
const addDbEntry_1 = __importDefault(require("../../../db/addDbEntry"));
const numberfy_1 = __importDefault(require("../../../../../utils/numberfy"));
const grab_user_resource_1 = __importDefault(require("../../../../web-app/db/grab-user-resource"));
function suAddBackup(_a) {
    return __awaiter(this, arguments, void 0, function* ({ targetUserId, }) {
        var _b, _c;
        try {
            const { mainBackupDir, userBackupDir } = (0, grab_dir_names_1.default)({
                userId: targetUserId,
            });
            if (targetUserId && !userBackupDir) {
                return {
                    success: false,
                    msg: `Error grabbing user backup directory`,
                };
            }
            const newBackup = {
                user_id: targetUserId ? (0, numberfy_1.default)(targetUserId) : undefined,
            };
            const newBackupEntry = yield (0, addDbEntry_1.default)({
                tableName: "backups",
                data: newBackup,
            });
            if (!((_b = newBackupEntry === null || newBackupEntry === void 0 ? void 0 : newBackupEntry.payload) === null || _b === void 0 ? void 0 : _b.insertId)) {
                return {
                    success: false,
                    msg: `Couldn't create new backup entry`,
                };
            }
            const { single: newlyAddedBackup } = yield (0, grab_user_resource_1.default)({
                tableName: "backups",
                targetID: (_c = newBackupEntry.payload) === null || _c === void 0 ? void 0 : _c.insertId,
                isSuperUser: true,
            });
            if (!(newlyAddedBackup === null || newlyAddedBackup === void 0 ? void 0 : newlyAddedBackup.id)) {
                return {
                    success: false,
                    msg: `Couldn't fetch newly added backup`,
                };
            }
            const writeBackup = yield (0, write_backup_files_1.default)({
                backup: newlyAddedBackup,
            });
            return writeBackup;
        }
        catch (error) {
            return {
                success: false,
                msg: `Backup add failed`,
                error: error.message,
            };
        }
    });
}
