import { DSQL_TableSchemaType } from "../../types";
import { ConnectionConfig } from "mariadb";
type Param<T extends {
    [k: string]: any;
} = {
    [k: string]: any;
}> = {
    query: string;
    values?: string[] | object;
    noErrorLogs?: boolean;
    database?: string;
    tableSchema?: DSQL_TableSchemaType;
    config?: ConnectionConfig;
};
/**
 * # Main DB Handler Function
 * @requires DSQL_DB_CONN - Gobal Variable for Datasquirel Database
 */
export default function dbHandler<T extends {
    [k: string]: any;
} = {
    [k: string]: any;
}>({ query, values, noErrorLogs, database, config, }: Param<T>): Promise<T[] | T | null>;
export {};
