"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = fullAccessDbHandler;
const conn_db_handler_1 = __importDefault(require("../../utils/db/conn-db-handler"));
const parseDbResults_1 = __importDefault(require("./parseDbResults"));
const serverError_1 = __importDefault(require("./serverError"));
/**
 * # Full Access Db Handler
 */
function fullAccessDbHandler(_a) {
    return __awaiter(this, arguments, void 0, function* ({ queryString, tableSchema, queryValuesArray, }) {
        /**
         * Declare variables
         *
         * @description Declare "results" variable
         */
        let results;
        /**
         * Fetch from db
         *
         * @description Fetch data from db if no cache
         */
        try {
            results = yield (0, conn_db_handler_1.default)(null, queryString, queryValuesArray);
            ////////////////////////////////////////
        }
        catch (error) {
            ////////////////////////////////////////
            console.log("Full Access DB Handler Error =>", error.message);
            (0, serverError_1.default)({
                component: "fullAccessDbHandler",
                message: error.message,
            });
            /**
             * Return error
             */
            return error.message;
        }
        finally {
        }
        /**
         * Return results
         *
         * @description Return results add to cache if "req" param is passed
         */
        if (results && tableSchema) {
            const unparsedResults = results;
            const parsedResults = yield (0, parseDbResults_1.default)({
                unparsedResults: unparsedResults,
                tableSchema: tableSchema,
            });
            return parsedResults;
        }
        else if (results) {
            return results;
        }
        else {
            return null;
        }
    });
}
