"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = grabMariadbMainUserForUser;
const dbHandler_1 = __importDefault(require("./dbHandler"));
const crud_1 = __importDefault(require("../../utils/data-fetching/crud"));
const decrypt_1 = __importDefault(require("../dsql/decrypt"));
const create_user_sql_user_1 = __importDefault(require("../../utils/create-user-sql-user"));
const grab_user_main_sql_user_name_1 = __importDefault(require("../../utils/grab-user-main-sql-user-name"));
function grabMariadbMainUserForUser(_a) {
    return __awaiter(this, arguments, void 0, function* ({ user, }) {
        var _b;
        const { fullName, host, username: mariaDBUsername, webHost, } = (0, grab_user_main_sql_user_name_1.default)({ user });
        const existingWebAppUser = (yield (0, dbHandler_1.default)({
            query: `SELECT * FROM mysql.user WHERE user=? AND host=?`,
            values: [mariaDBUsername, webHost],
        }));
        if (!(existingWebAppUser === null || existingWebAppUser === void 0 ? void 0 : existingWebAppUser[0])) {
            return yield (0, create_user_sql_user_1.default)(user);
        }
        else {
            const existingUserRecord = yield (0, crud_1.default)({
                action: "get",
                table: "users",
                query: {
                    query: {
                        id: {
                            value: String(user.id),
                        },
                    },
                },
            });
            const targetUser = (_b = existingUserRecord === null || existingUserRecord === void 0 ? void 0 : existingUserRecord.payload) === null || _b === void 0 ? void 0 : _b[0];
            if (!(targetUser === null || targetUser === void 0 ? void 0 : targetUser.id)) {
                return {};
            }
            return {
                fullName,
                host,
                username: mariaDBUsername,
                password: (0, decrypt_1.default)({
                    encryptedString: targetUser.mariadb_pass || "",
                }),
            };
        }
    });
}
