"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = default_1;
const lodash_1 = __importDefault(require("lodash"));
const resource_limits_1 = __importDefault(require("../../../../dict/resource-limits"));
const numberfy_1 = __importDefault(require("../../../../utils/numberfy"));
function default_1(params) {
    let queryObject = {
        limit: (params === null || params === void 0 ? void 0 : params.noLimit) ? undefined : resource_limits_1.default["general"],
        order: {
            field: "id",
            strategy: "DESC",
        },
    };
    if (params === null || params === void 0 ? void 0 : params.targetID) {
        const targetIDQuery = {
            query: {
                id: {
                    value: (0, numberfy_1.default)(params.targetID).toString(),
                },
            },
        };
        queryObject = lodash_1.default.merge(queryObject, targetIDQuery);
    }
    let queryFixedObject = (params === null || params === void 0 ? void 0 : params.isSuperUser)
        ? {}
        : {
            query: {
                user_id: {
                    value: String((params === null || params === void 0 ? void 0 : params.userId) || 0),
                },
            },
        };
    return lodash_1.default.merge(queryObject, params === null || params === void 0 ? void 0 : params.query, queryFixedObject);
}
