"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = handleMariadbUserCreation;
exports.createNewSQLUser = createNewSQLUser;
const dbHandler_1 = __importDefault(require("../../backend/dbHandler"));
const normalize_text_1 = __importDefault(require("../../../utils/normalize-text"));
const decrypt_1 = __importDefault(require("../../dsql/decrypt"));
function handleMariadbUserCreation(_a) {
    return __awaiter(this, arguments, void 0, function* ({ user, existingRecord, updatedRecord, }) {
        const parsedPassword = (0, decrypt_1.default)({
            encryptedString: (updatedRecord === null || updatedRecord === void 0 ? void 0 : updatedRecord.password) || "",
        });
        if ((existingRecord === null || existingRecord === void 0 ? void 0 : existingRecord.id) && (updatedRecord === null || updatedRecord === void 0 ? void 0 : updatedRecord.id)) {
            if (existingRecord.username !== updatedRecord.username ||
                existingRecord.host !== updatedRecord.host) {
                const renameSQLUser = yield (0, dbHandler_1.default)({
                    query: (0, normalize_text_1.default)(`
                    RENAME USER '${existingRecord.username}'@'${existingRecord.host}' \
                    TO '${updatedRecord.username}'@'${updatedRecord.host}'
                `),
                });
                if (!renameSQLUser) {
                    yield createNewSQLUser({
                        host: updatedRecord.host,
                        password: parsedPassword,
                        username: updatedRecord.username,
                    });
                }
            }
            const updateSQLUser = yield (0, dbHandler_1.default)({
                query: (0, normalize_text_1.default)(`
                ALTER USER '${updatedRecord.username}'@'${updatedRecord.host}' \
                IDENTIFIED BY '${parsedPassword}'
            `),
            });
            if (!updateSQLUser) {
                yield createNewSQLUser({
                    host: updatedRecord.host,
                    password: parsedPassword,
                    username: updatedRecord.username,
                });
            }
        }
        else if (!(existingRecord === null || existingRecord === void 0 ? void 0 : existingRecord.id) && (updatedRecord === null || updatedRecord === void 0 ? void 0 : updatedRecord.id)) {
            yield createNewSQLUser({
                host: updatedRecord.host,
                password: parsedPassword,
                username: updatedRecord.username,
            });
        }
        return { success: true };
    });
}
function createNewSQLUser(_a) {
    return __awaiter(this, arguments, void 0, function* ({ host, password, username, }) {
        return yield (0, dbHandler_1.default)({
            query: `CREATE USER IF NOT EXISTS '${username}'@'${host}' IDENTIFIED BY '${password}'`,
        });
    });
}
