"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("dotenv").config({ path: "./../.env" });
const grab_dsql_connection_1 = __importDefault(require("../utils/grab-dsql-connection"));
const grab_sql_key_name_1 = __importDefault(require("../utils/grab-sql-key-name"));
/**
 * # Main DB Handler Function
 * @async
 *
 * @param {object} params
 * @param {string} params.query
 * @param {string[] | object} [params.values]
 * @param {string} [params.database]
 *
 * @returns {Promise<object|null>}
 */
(() => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const CONNECTION = yield (0, grab_dsql_connection_1.default)();
    try {
        const [result] = yield CONNECTION.query("SELECT user,host,ssl_type FROM mysql.user");
        for (let i = 0; i < result.length; i++) {
            const user = result[i];
            if (user.User !== process.env.DSQL_DB_READ_ONLY_USERNAME ||
                user.User !== process.env.DSQL_DB_FULL_ACCESS_USERNAME ||
                !((_a = user.User) === null || _a === void 0 ? void 0 : _a.match(new RegExp((0, grab_sql_key_name_1.default)({ type: "user" }))))) {
                continue;
            }
            const { User, Host, ssl_type } = user;
            if (ssl_type === "ANY") {
                continue;
            }
            const [addUserSSL] = yield CONNECTION.query(`ALTER USER '${User}'@'${Host}'`);
            console.log(`addUserSSL => ${User}@${Host}`, addUserSSL);
        }
    }
    catch (error) {
        console.log("Error =\u003e", error.message);
    }
    finally {
        yield (CONNECTION === null || CONNECTION === void 0 ? void 0 : CONNECTION.end());
        process.exit();
    }
}))();
