"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = dropAllForeignKeys;
const grab_sql_key_name_1 = __importDefault(require("../../utils/grab-sql-key-name"));
const dbHandler_1 = __importDefault(require("../../functions/backend/dbHandler"));
/**
 * # Drop All Foreign Keys
 */
function dropAllForeignKeys(_a) {
    return __awaiter(this, arguments, void 0, function* ({ dbFullName, tableName, }) {
        try {
            // const rows = await varDatabaseDbHandler({
            //     queryString: `SELECT CONSTRAINT_NAME FROM information_schema.REFERENTIAL_CONSTRAINTS WHERE TABLE_NAME = '${tableName}' AND CONSTRAINT_SCHEMA = '${dbFullName}'`,
            // });
            // console.log("rows", rows);
            // console.log("dbFullName", dbFullName);
            // console.log("tableName", tableName);
            // for (const row of rows) {
            //     await varDatabaseDbHandler({
            //         queryString: `ALTER TABLE \`${dbFullName}\`.\`${tableName}\` DROP FOREIGN KEY \`${row.CONSTRAINT_NAME}\`
            //     `,
            //     });
            // }
            const foreignKeys = (yield (0, dbHandler_1.default)({
                query: `SHOW INDEXES FROM \`${dbFullName}\`.\`${tableName}\` WHERE Key_name LIKE '${(0, grab_sql_key_name_1.default)({ type: "foreign_key" })}%'`,
            }));
            for (const fk of foreignKeys) {
                if (fk.Key_name.match(new RegExp((0, grab_sql_key_name_1.default)({ type: "foreign_key" })))) {
                    yield (0, dbHandler_1.default)({
                        query: `ALTER TABLE \`${dbFullName}\`.\`${tableName}\` DROP INDEX \`${fk.Key_name}\`
                `,
                    });
                }
            }
        }
        catch (error) {
            console.log(`dropAllForeignKeys ERROR => ${error.message}`);
        }
    });
}
