import { DATASQUIREL_LoggedInUser, UserType } from "../../../types";
type Param = {
    user?: DATASQUIREL_LoggedInUser | UserType;
    userId?: string | number | null;
    appDir?: string;
    dataDir?: string;
};
export default function grabDirNames(param?: Param): {
    appDir: string;
    privateDataDir: string;
    oldSchemasDir: string;
    userConfigJSONFilePath: string | undefined;
    mainShemaJSONFilePath: string;
    mainDbTypeDefFile: string;
    tempDirName: string;
    defaultTableFieldsJSONFilePath: string;
    usersSchemaDir: string;
    targetUserPrivateDir: string | undefined;
    userSchemaMainJSONFilePath: string | undefined;
    userPrivateMediaDir: string | undefined;
    userPrivateExportsDir: string | undefined;
    userPrivateSQLExportsDir: string | undefined;
    userPrivateTempSQLExportsDir: string | undefined;
    userPrivateTempJSONSchemaFilePath: string | undefined;
    userPrivateDbExportZipFileName: string;
    userPrivateDbExportZipFilePath: string | undefined;
    userPrivateDbImportZipFileName: string;
    userPrivateDbImportZipFilePath: string | undefined;
    dbNginxLoadBalancerConfigFile: string;
    dockerComposeFile: string;
    dockerComposeFileAlt: string;
    dsqlDockerComposeFile: string;
    dsqlDockerComposeFileAlt: string;
    extraDockerComposeFile: string;
    extraDockerComposeFileAlt: string;
    siteSetupFile: string;
    envFile: string;
    dsqlEnvFileName: string;
    dsqlEnvFile: string;
    userPublicMediaDir: string | undefined;
    userTempSQLFilePath: string | undefined;
    STATIC_ROOT: string;
    appConfigJSONFile: string;
    appConfigDir: string;
    mariadbMainConfigDir: string;
    mariadbMainConfigFile: string;
    maxscaleConfigDir: string;
    mariadbReplicaConfigDir: string;
    DATA_DIR: string;
    publicDir: string;
    publicSSLDir: string;
    appSSLDir: string;
    maxscaleConfigFile: string;
    mariadbReplicaConfigFile: string;
    mainSSLDir: string;
    mainDbDataDir: string;
    replica1DbDataDir: string;
    galeraConfigFile: string;
    galeraReplicaConfigFile: string;
    dbDockerComposeFile: string;
    dbDockerComposeFileAlt: string;
    mainDbGrastateDatFile: string;
    appSchemaJSONFile: string;
    mainBackupDir: string;
    userBackupDir: string | undefined;
    sqlBackupDirName: string;
    schemasBackupDirName: string;
    userMainShemaJSONFilePath: string | undefined;
    maxscaleSSLDir: string;
    maxscaleSSLCaCertFile: string;
    mainDBSSLDir: string;
    replica1DBSSLDir: string;
    replica2DBSSLDir: string;
    staticConfigDir: string;
    staticNGINXConfigFile: string;
    mainReverseProxyConfigDir: string;
    mainReverseProxyConfigFile: string;
    mainReverseProxyTemplatesDir: string;
    mainReverseProxyTemplatesDefaultFile: string;
    dsqlDockerComposeFileName: string;
    dsqlDockerComposeFileNameAlt: string;
    distroDirName: "distro";
    distroAppDirName: "dsql-app";
    distroDataDirName: "dsql-data";
    distroCommunityName: "dsql-community";
    distroCommunityExportTarName: "dsql-community.tar.xz";
    distroProName: "dsql-pro";
    distroProExportTarName: "dsql-pro.tar.xz";
    distroEnterpriseName: "dsql-enterprise";
    distroEnterpriseExportTarName: "dsql-enterprise.tar.xz";
    communityDistroTempDir: string;
    communityDistroDir: string;
    installScriptFile: string;
    updateScriptFile: string;
    installTypescriptFile: string;
    updateTypescriptFile: string;
    dsqlDbDockerComposeFile: string;
    dsqlDbDockerComposeFileAlt: string;
    dsqlDbDockerComposeFileName: string;
    dsqlDbDockerComposeFileNameAlt: string;
};
export {};
