import { DSQLErrorObject } from "../../types";
import mariadb, { ConnectionConfig } from "mariadb";
export type ConnDBHandlerQueryObject = {
    query: string;
    values?: (string | number | undefined)[];
};
type Return<ReturnType = any> = ReturnType | ReturnType[] | null | {
    error?: string;
    errors?: DSQLErrorObject[];
    config?: ConnectionConfig;
};
/**
 * # Run Query From MySQL Connection
 * @description Run a query from a pre-existing MySQL/Mariadb Connection
 * setup with `serverless-mysql` npm module
 */
export default function connDbHandler<ReturnType = any>(
/**
 * MariaDB Connection
 */
conn?: mariadb.Connection | null, 
/**
 * String Or `ConnDBHandlerQueryObject` Array
 */
query?: ConnDBHandlerQueryObject["query"] | ConnDBHandlerQueryObject[], 
/**
 * Array of Values to Sanitize and Inject
 */
values?: ConnDBHandlerQueryObject["values"], debug?: boolean): Promise<Return<ReturnType>>;
export {};
