"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataTypesWithTwoNumbers = exports.DataTypesWithNumbers = void 0;
exports.default = dataTypeParser;
const numberfy_1 = __importDefault(require("../../numberfy"));
exports.DataTypesWithNumbers = [
    "DECIMAL",
    "DOUBLE",
    "FLOAT",
    "VARCHAR",
];
exports.DataTypesWithTwoNumbers = [
    "DECIMAL",
    "DOUBLE",
    "FLOAT",
];
function dataTypeParser(dataType) {
    if (!dataType) {
        return {
            type: "VARCHAR",
            limit: 250,
        };
    }
    const dataTypeArray = dataType.split("(");
    const type = dataTypeArray[0];
    const number = dataTypeArray[1];
    if (!exports.DataTypesWithNumbers.includes(type)) {
        return {
            type,
        };
    }
    if (number === null || number === void 0 ? void 0 : number.match(/,/)) {
        const numberArr = number.split(",");
        return {
            type,
            limit: (0, numberfy_1.default)(numberArr[0]),
            decimal: numberArr[1] ? (0, numberfy_1.default)(numberArr[1]) : undefined,
        };
    }
    return {
        type,
        limit: number ? (0, numberfy_1.default)(number) : undefined,
    };
}
