"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = resolveSchemaChildren;
const lodash_1 = __importDefault(require("lodash"));
const resolve_schema_children_handle_children_databases_1 = __importDefault(require("./resolve-schema-children-handle-children-databases"));
const resolve_schema_children_handle_children_tables_1 = __importDefault(require("./resolve-schema-children-handle-children-tables"));
function resolveSchemaChildren({ dbSchema, userId }) {
    let newDbSchema = lodash_1.default.cloneDeep(dbSchema);
    newDbSchema = (0, resolve_schema_children_handle_children_databases_1.default)({
        currentDbSchema: newDbSchema,
        userId,
    });
    for (let t = 0; t < newDbSchema.tables.length; t++) {
        const tableSchema = newDbSchema.tables[t];
        newDbSchema = (0, resolve_schema_children_handle_children_tables_1.default)({
            currentDbSchema: newDbSchema,
            currentTableSchema: tableSchema,
            currentTableSchemaIndex: t,
            userId,
        });
    }
    return newDbSchema;
}
