"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = grabDbFullName;
const slugify_1 = __importDefault(require("./slugify"));
/**
 * # Grab full database name
 * @description Grab full database name from slug or full name
 * @param param0
 * @returns
 */
function grabDbFullName({ dbName, userId, user, }) {
    const finalUserId = (user === null || user === void 0 ? void 0 : user.id) || userId;
    if (!finalUserId) {
        return dbName;
    }
    if (!dbName) {
        return;
    }
    const dbNamePrefix = process.env.DSQL_USER_DB_PREFIX;
    const parsedDbName = (0, slugify_1.default)(dbName, "_");
    const dbSlug = parsedDbName.replace(new RegExp(`${dbNamePrefix}_?\\d+_`), "");
    return (0, slugify_1.default)(`${dbNamePrefix}_${finalUserId}_${dbSlug}`, "_");
}
