"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = grabUserMainSqlUserName;
const grab_sql_user_name_for_user_1 = __importDefault(require("./grab-sql-user-name-for-user"));
const grab_ip_addresses_1 = __importDefault(require("../utils/backend/names/grab-ip-addresses"));
function grabUserMainSqlUserName({ HOST, user, username, }) {
    const sqlUsername = (0, grab_sql_user_name_for_user_1.default)(user === null || user === void 0 ? void 0 : user.id);
    const { webAppIP, maxScaleIP } = (0, grab_ip_addresses_1.default)();
    const finalUsername = username || sqlUsername;
    const finalHost = HOST || maxScaleIP || "127.0.0.1";
    const fullName = `${finalUsername}@${webAppIP}`;
    return {
        username: finalUsername,
        host: finalHost,
        webHost: webAppIP,
        fullName,
        sqlUsername,
    };
}
