"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = mariaDBlocalQuery;
exports.removeQueryDoubleQuotes = removeQueryDoubleQuotes;
const grab_docker_stack_services_names_1 = __importDefault(require("./backend/names/grab-docker-stack-services-names"));
const execute_1 = __importDefault(require("./execute"));
const normalize_text_1 = __importDefault(require("./normalize-text"));
function mariaDBlocalQuery(query) {
    const { dbServiceName, maxScaleServiceName } = (0, grab_docker_stack_services_names_1.default)();
    const MARIADB_CMD_PREFIX = `docker exec ${dbServiceName} mariadb -u root -p"${process.env.DSQL_MARIADB_ROOT_PASSWORD}"`;
    function grabMariadbDockerCmd(cmd) {
        return `${MARIADB_CMD_PREFIX} -e "${removeQueryDoubleQuotes((0, normalize_text_1.default)(cmd))}"`;
    }
    const finalQuery = Array.isArray(query)
        ? query.map((qry) => grabMariadbDockerCmd(qry))
        : grabMariadbDockerCmd(query);
    return (0, execute_1.default)(finalQuery);
}
function removeQueryDoubleQuotes(query) {
    return query.replace(/\"/gm, '\\"');
}
