"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = setupDSQLDb;
const grabDbSSL_1 = __importDefault(require("./backend/grabDbSSL"));
const mariadb_1 = __importDefault(require("mariadb"));
function setupDSQLDb(_a) {
    return __awaiter(this, arguments, void 0, function* ({ dbConfig, ssl }) {
        const conn = yield mariadb_1.default.createConnection(Object.assign(Object.assign({ host: process.env.DSQL_DB_HOST, user: process.env.DSQL_DB_USERNAME, password: process.env.DSQL_DB_PASSWORD, database: process.env.DSQL_DB_NAME, charset: "utf8mb4" }, dbConfig), { ssl: ssl ? (0, grabDbSSL_1.default)() : undefined, supportBigNumbers: true, bigNumberStrings: false, dateStrings: true, bigIntAsNumber: true, metaAsArray: true }));
        // const conn = mariadb.createPool({
        //     host: process.env.DSQL_DB_HOST,
        //     user: process.env.DSQL_DB_USERNAME,
        //     password: process.env.DSQL_DB_PASSWORD,
        //     database: process.env.DSQL_DB_NAME,
        //     charset: "utf8mb4",
        //     ...dbConfig,
        //     ssl: ssl ? grabDbSSL() : undefined,
        //     connectionLimit,
        //     supportBigNumbers: true,
        //     bigNumberStrings: false,
        //     dateStrings: true,
        // });
        // let readOnlyConnection;
        // if (addReadOnlyConn) {
        //     readOnlyConnection = mariadb.createPool({
        //         host: process.env.DSQL_DB_HOST,
        //         user: process.env.DSQL_DB_READ_ONLY_USERNAME,
        //         password: process.env.DSQL_DB_READ_ONLY_PASSWORD,
        //         database: process.env.DSQL_DB_NAME,
        //         charset: "utf8mb4",
        //         ...readOnlyDbConfig,
        //         ssl: ssl ? grabDbSSL() : undefined,
        //         connectionLimit,
        //     });
        //     global.DSQL_READ_ONLY_DB_CONN = readOnlyConnection;
        // }
        return {
            conn,
            // readOnlyConnection,
        };
    });
}
