"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = testDbConnection;
const dbHandler_1 = __importDefault(require("../functions/backend/dbHandler"));
const sleep_1 = __importDefault(require("./sleep"));
let testDbConnRetries = 0;
const MAX_TEST_DB_CONN_RETRIES = 10;
const SLEEP_TIME = 2000;
function testDbConnection(params) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log("Testing Database Connection ...", testDbConnRetries);
        while (true) {
            testDbConnRetries++;
            try {
                const res = (yield (0, dbHandler_1.default)({ query: `SHOW DATABASES` }));
                if (res === null || res === void 0 ? void 0 : res[0]) {
                    console.log("Database Connection Complete!");
                    break;
                }
                yield (0, sleep_1.default)((params === null || params === void 0 ? void 0 : params.sleepTime) || SLEEP_TIME);
                if (testDbConnRetries >
                    ((params === null || params === void 0 ? void 0 : params.maxRetries) || MAX_TEST_DB_CONN_RETRIES)) {
                    console.log("Database Connection Failed!");
                    process.exit(1);
                }
            }
            catch (error) {
                yield (0, sleep_1.default)((params === null || params === void 0 ? void 0 : params.sleepTime) || SLEEP_TIME);
            }
        }
        return true;
    });
}
