import addUser from "../../actions/users/add-user";
import getUser from "../../actions/users/get-user";
import loginUser from "../../actions/users/login-user";
import logoutUser from "../../actions/users/logout-user";
import resetPassword from "../../actions/users/reset-password";
import sendEmailCode from "../../actions/users/send-email-code";
import googleAuth from "../../actions/users/social/google-auth";
import updateUser from "../../actions/users/update-user";
import userAuth from "../../actions/users/user-auth";
import validateTempEmailCode from "../../actions/users/validate-temp-email-code";

import {
    AddUserParams,
    GetUserParams,
    GoogleAuthParams,
    LoginUserParam,
    ResetPasswordParams,
    SendEmailCodeParams,
    UpdateUserParams,
} from "../../types";

const localUser = {
    auth: {
        login: async (_: LoginUserParam) => {
            return await loginUser({ ..._, useLocal: true });
        },
        get: async (_: GetUserParams) => {
            return await getUser({ ..._, useLocal: true });
        },
        signup: async (_: AddUserParams) => {
            return await addUser({ ..._, useLocal: true });
        },
        sendEmailCode: async (_: SendEmailCodeParams) => {
            return await sendEmailCode({ ..._, useLocal: true });
        },
        update: async (_: UpdateUserParams) => {
            return await updateUser({ ..._, useLocal: true });
        },
        resetPassword: async (_: ResetPasswordParams) => {
            return await resetPassword({ ..._, useLocal: true });
        },
        googleLogin: async (_: GoogleAuthParams) => {
            return await googleAuth({ ..._, useLocal: true });
        },
        logout: logoutUser,
        auth: userAuth,
        validateTempEmailCode,
    },
};

export default localUser;
