import { UserType } from "../../types";
import grabDbSSL from "../../utils/backend/grabDbSSL";
import connDbHandler from "../../utils/db/conn-db-handler";
import mariadb from "mariadb";

type Params = {
    query?: string;
    values?: any[];
    database?: string;
    user: UserType;
};

export default async function suDbHandler({
    query,
    database,
    user,
    values,
}: Params) {
    const connection = await mariadb.createConnection({
        host: process.env.DSQL_DB_HOST,
        user: process.env.DSQL_DB_USERNAME,
        password: process.env.DSQL_DB_PASSWORD,
        database: database,
        charset: "utf8mb4",
        ssl: grabDbSSL(),
        supportBigNumbers: true,
        bigNumberStrings: false,
        dateStrings: true,
        bigIntAsNumber: true,
        metaAsArray: true,
    });

    // const connection = mariadb.createPool({
    //     host: process.env.DSQL_DB_HOST,
    //     user: process.env.DSQL_DB_USERNAME,
    //     password: process.env.DSQL_DB_PASSWORD,
    //     database: database,
    //     charset: "utf8mb4",
    //     ssl: grabDbSSL(),
    //     supportBigNumbers: true,
    //     bigNumberStrings: false,
    //     dateStrings: true,
    // });

    const results = await connDbHandler(connection, query);

    return results;
}
