export const TriggerParadigms = ["sync_tables", "sync_dbs"] as const;

type Params = {
    userId?: string | number;
    paradigm: (typeof TriggerParadigms)[number];
    dbId?: string | number;
    tableName?: string;
};

export default function grabTriggerName({
    userId,
    paradigm,
    dbId,
    tableName,
}: Params) {
    let triggerName = `dsql_trig_${paradigm}`;

    if (userId) triggerName += `_${userId}`;
    if (dbId) triggerName += `_${dbId}`;
    if (tableName) triggerName += `_${tableName}`;

    return triggerName;
}
