import { SiteConfigMain } from "../../../types";
import grabConfig from "./grab-config";

type Params = {
    userId?: string | number;
};

type Return = {
    appMainConfig: SiteConfigMain;
    userMainConfig?: SiteConfigMain;
};

export default function grabMainConfig(params?: Params): Return {
    const { appConfig } = grabConfig();
    const { userConfig } = grabConfig({ userId: params?.userId });

    return { appMainConfig: appConfig.main, userMainConfig: userConfig?.main };
}
