import { GrabUserAPIPathParams } from "../../../types";

export default function grabUserDSQLAPIPath({
    apiVersion,
    paradigm,
    action,
    database,
    userID,
}: GrabUserAPIPathParams) {
    const finalAPIVersion = process.env.DSQL_API_VERSION || apiVersion || "v1";
    const finalParadigm = paradigm || "auth";
    const finalAction = action || "login";

    const finalDatabase = database || process.env.DSQL_DB_NAME || "datasquirel";

    let finalPath = `/api/${finalAPIVersion}/users/${finalParadigm}/${finalDatabase}`;

    switch (paradigm) {
        case "auth":
            finalPath += `/${finalAction}`;
            if (userID) {
                finalPath += `/${userID}`;
            }
            break;

        default:
            break;
    }

    return finalPath;
}
