import { DSQL_FieldSchemaType, TextFieldTypesArray } from "../../../types";
import _ from "lodash";

export default function setTextFieldType(
    field: DSQL_FieldSchemaType,
    type?: (typeof TextFieldTypesArray)[number]["value"]
): DSQL_FieldSchemaType {
    const newField = _.cloneDeep(field);

    delete newField.css;
    delete newField.richText;
    delete newField.json;
    delete newField.shell;
    delete newField.html;
    delete newField.javascript;
    delete newField.yaml;
    delete newField.code;

    delete newField.defaultValueLiteral;

    if (type == "css") return { ...newField, css: true };
    if (type == "richText") return { ...newField, richText: true };
    if (type == "json") return { ...newField, json: true };
    if (type == "shell") return { ...newField, shell: true };
    if (type == "html") return { ...newField, html: true };
    if (type == "yaml") return { ...newField, yaml: true };
    if (type == "javascript") return { ...newField, javascript: true };
    if (type == "code") return { ...newField, code: true };

    return { ...newField };
}
