const APIParadigms = ["crud", "media", "schema"] as const;

type Params = {
    version?: string;
    paradigm?: (typeof APIParadigms)[number];
};

export default function grabAPIBasePath({ version, paradigm }: Params): string {
    let basePath = `/api/v${version || "1"}`;

    if (paradigm) {
        basePath += `/${paradigm}`;
    }

    return basePath;
}
