import { UserType } from "../types";
import grabDbFullName from "./grab-db-full-name";

type Param = {
    /**
     * Database full name or slug
     */
    dbName?: string;
    userId?: string | number;
    user?: UserType | null;
};

/**
 * # Grab full database name
 * @description Grab full database name from slug or full name
 * @param param0
 * @returns
 */
export default function grabDbNames({ dbName, userId, user }: Param) {
    const dbNamePrefix = process.env.DSQL_USER_DB_PREFIX;
    const finalUserId = user?.id || userId;
    const userDbPrefix = `${dbNamePrefix}${finalUserId}_`;

    const dbFullName = grabDbFullName({ dbName, user, userId });

    return { userDbPrefix, dbFullName, dbNamePrefix };
}
